﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WinGridDifferentButton
{
    public partial class Form1 : Form
    {
        UltraGridCell lastCell;

        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DataSource = DepartmentList();
        }

        private DataTable DepartmentList()
        {
            DataTable dt = new DataTable();
            DataColumn dc;


            //Create columns
            dc = new DataColumn();
            dc.DataType = typeof(int);
            dc.ColumnName = "NumRow";
            dt.Columns.Add(dc);

            //Add data
            for (int i = 0; i < 10; i++)
            {
                DataRow dr = dt.NewRow();
                dr["NumRow"] = i;
                dt.Rows.Add(dr);
            }


            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridColumn col = e.Layout.Bands[0].Columns.Add("btn", "btn");
            col.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            col.ButtonDisplayStyle = ButtonDisplayStyle.Always;
            col.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Center;
            
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells["btn"].Value = "+";
            if (lastCell != null)
            {
                lastCell.Value = "X";
            }
            lastCell = e.Row.Cells["btn"];
        }

        private void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {
        }

        private void ultraGrid1_ClickCellButton(object sender, CellEventArgs e)
        {
            if (e.Cell.Value.ToString() == "X")
            {
                e.Cell.Row.Delete();
                return;
            }
             if (e.Cell.Value.ToString() == "+")
             {
                 ((DataTable)ultraGrid1.DataSource).Rows.Add(
                     ((DataTable)ultraGrid1.DataSource).Rows.Count + 1);
                 return;
             } 
           
        }

        private void ultraGrid1_BeforeRowsDeleted(object sender, BeforeRowsDeletedEventArgs e)
        {
            e.DisplayPromptMsg = false;
        }
    }
}
